/*
[]=========================================================================[]

Copyright(C) 2008, Feitian Technologies Co., Ltd.
All rights reserved.
 
FILE:
	FT_ET299_API.h
	
DESC:
	ET299 interface and defines 
		
[]=========================================================================[]
*/

#ifndef  __FT_ET299_HEADER_H
#define  __FT_ET299_HEADER_H

#ifdef __cplusplus
extern "C" {
#endif


//Return Value Status Definition
#define	  ET_SUCCESS				0x00			//ִгɹ
#define   ET_ACCESS_DENY            0x01			//ʱܾȨ޲
#define   ET_COMMUNICATIONS_ERROR   0x02			//ͨѶûд豸
#define   ET_INVALID_PARAMETER      0x03			//ЧĲ
#define   ET_NOT_SET_PID            0x04			//ûPID
#define   ET_UNIT_NOT_FOUND 	    0x05			//ָ豸ʧ
#define   ET_HARD_ERROR             0x06			//Ӳ
#define   ET_UNKNOWN                0x07			//һԴ
#define	  ET_PIN_ERR_MASK			0x0F			//֤PIN
#define	  ET_PIN_ERR_MAX		    0xFF            //֤PINʣ֤󻹻ET_PIN_ERR_MAXʾPINԶ

//
#define	  ET_KEY_TYPE				0X10			//Կʹ
#define	  ET_LICENSE_TYPE			0X11			//Ȩʹ
#define	  ET_LICENSE_UNINIT			0x12			//ȨԪδãʱȫȨԪδãֻеȨŻᱻ
#define   ET_NO_LICENSE				0x13			//Ȩʧ
#define   ET_UNKNOWN_UPDATE_FILE	0x14			//δ֪ļʽ
#define	  ET_INVALID_DATA_LEN		0x15			//Ƿݳ
#define   ET_NO_TDES_KEY			0x16			//ЧTDESԿ
#define   ET_INVALID_UPDATE_FILE	0x17			//Чļ
#define	  ET_UNSUPPORTED			0x18			//ֵ֧Ĺ
#define	  ET_ADJUST_TIMER			0x19			//ϵͳʱʧ
#define	  ET_KEY_INDEX				0X1A			//Կ
#define	  ET_KEY_ZERO				0X1B			//0ԿΪϵͳר

//linux
#define   ET_TOOMUCHTHREAD		0x1C    //ͬһд߳ > 100

//
#define ET299_MEMORY_SIZE			6*1024			//ET299С 

//õPID
#define CONST_PID                   "FFFFFFFF"

struct SYSTEMTIME {
    unsigned short wYear; 
    unsigned short wMonth; 
    unsigned short wDayOfWeek; 
    unsigned short wDay; 
    unsigned short wHour; 
    unsigned short wMinute; 
    unsigned short wSecond; 
    unsigned short wMilliseconds; 
} ; 

//ET299PIDҵET299Ŀ
unsigned long 	et_FindToken(unsigned char* pid/*[in]*/,int * count);

//ָPIDET299PID
unsigned long 	et_OpenToken(int* pHandle,unsigned char* pid,int index);

//رET299
unsigned long 	et_CloseToken(int hHandle);

//ET299
unsigned long 	et_Read(int hHandle,unsigned short offset,int Len,unsigned char* pucReadBuf);

//дET299
unsigned long 	et_Write(int hHandle,unsigned short offset,int Len,unsigned char* pucWriteBuf);

//PID,ӺͳȣµPID
unsigned long 	et_GenPID(int hHandle,int SeedLen,unsigned char* pucSeed,unsigned char* pid);

//
unsigned long 	et_GenRandom(int hHandle,unsigned char* pucRandBuf);

//µSoPINӺͳȣµSoPIN
unsigned long 	et_GenSOPIN(int hHandle,int SeedLen,unsigned char* pucSeed, unsigned char* pucNewSoPIN);

//UserPIN
unsigned long 	et_ResetPIN(int hHandle,unsigned char* pucSoPIN);

//ԿԭET99ӿڣֻHMAC-MD5ԿԿ32ֽ
unsigned long 	et_SetKey(int hHandle,int Keyid, unsigned char* pucKeyBuf);

//ԿչԭET99ӿڣTDESԿ,3DESԿ16ֽ
unsigned long 	et_SetKeyEx(int hHandle,int keyType,int Keyid, unsigned char* keyBuf);
//ѡԿ
#define ET_KEY_HMAC_MD5			0	//ѡHMAC-MD5Կ	
#define ET_KEY_TDES				1	//ѡ3DESԿ

//HMAC-MD5㣬Կݼȣ16ֽժҪ
unsigned long 	et_HMAC_MD5(int hHandle,int keyID,int textLen,unsigned char* pucText,unsigned char *digest);

//֤PIN
unsigned long 	et_Verify(int hHandle,int Flags,unsigned char* pucPIN);

//define pin Flags
#define ET_VERIFY_USERPIN			0
#define ET_VERIFY_SOPIN				1

//UserPINԭUserPINµUserPIN
unsigned long 	et_ChangeUserPIN(int hHandle,unsigned char* pucOldPIN,unsigned char* pucNewPIN);

//ðȫ״̬
unsigned long 	et_ResetSecurityState(int hHandle);//Ҫõet_logoff

//Ӳкţʱ8ֽӲкţûɸ
unsigned long 	et_GetSN(int hHandle,unsigned char* pucSN/*8bytes*/);

//ET2999SoPINԴUserPINԴUSERPINֻ
unsigned long 	et_SetupToken(int hHandle,unsigned char bSoPINRetries,unsigned char bUserPINRetries,unsigned char bUserReadOnly,unsigned char bBack);

#define ET_USER_WRITE_READ				0	//д
#define ET_USER_READ_ONLY				1	//ֻ

//ET299ָʾ
unsigned long 	et_TurnOnLED(int hHandle);

//رET299ָʾ
unsigned long 	et_TurnOffLED(int hHandle);

//ȡԶӲк
unsigned long 	et_GetSNEx(int hHandle, unsigned char* pucSN,int* len);

//ԶӲк
unsigned long 	et_SetSNEx(int hHandle,unsigned char* pucSNEx,int len);

//RSAԿԣe=65537 أRSAԿֻڴʱأκʱ޷ȡ
unsigned long 	et_RSAGenKey(int hHandle,int keyLen,unsigned char* pBufferRSA_N, unsigned char* pBufferRSA_D);

#define RSA_KEY_LEN_1024	1024	//RSA ԿΪ1024λ
	
//RSAԿԣRSA
unsigned long 	et_RSASetKey(int hHandle,int keyLen,unsigned char* pBufferRSA_N, unsigned char* pBufferRSA_D);
//ԶרRSAԿԣԶ
unsigned long 	et_RSASetUpdateKey(int hHandle,int keyLen,unsigned char* pBufferRSA_N, unsigned char* pBufferRSA_D);

#define ET_RSA_PKCS1_PADDING	1	//PKCS#1䷽ʽ
#define ET_RSA_NO_PADDING		2	//
//RSAԿ
unsigned long 	et_RSAPublicEncrypt(int hHandle,unsigned char* buffer,int *len,int nFillMode);

//RSAԿ
unsigned long 	et_RSAPublicDecrypt(int hHandle,unsigned char* buffer,int *len,int nFillMode);

//RSA˽Կ
unsigned long   et_RSAPrivateEncrypt(int hHandle,unsigned char* buffer,int* len,int nFillMode);

//RSA˽Կ
unsigned long 	et_RSAPrivateDecrypt(int hHandle,unsigned char* buffer,int* len,int nFillMode);

//3DES
unsigned long 	et_TDesEncrypt(int hHandle,int keyIndex,unsigned char* buffer,int len);

//3DES
unsigned long 	et_TDesDecrypt(int hHandle, int keyIndex,unsigned char* buffer,int len);

//ʱȨ
unsigned long 	et_SetTimeLicense(int hHandle, int unitIndex,int timeMode,unsigned char* newTime);

#define ET_EXPIRE_DATE		0	//ֹȨ
#define ET_TIME_MINUTE		1	//ʱȨ(λ)
#define ET_TIME_DAY			2	//Ȩ(λ)

//ȡʱȨ
unsigned long 	et_GetTimeLicense(int hHandle, int unitIndex,int *timeMode,unsigned char* newTime);

//ʱȨ
unsigned long 	et_StartTimeUnit (int hHandle, int unitIndex);

//ʱȨ
unsigned long 	et_StopTimeUnit (int hHandle, int unitIndex);

//ET299ϵͳʱ
unsigned long 	et_AdjustTimer(int hHandle, unsigned char* newTime);

//üƴȨ
unsigned long 	et_SetCountLicense(int hHandle, int unitIndex,unsigned long count, unsigned char type);

//ȡƴȨ
unsigned long 	et_GetCountLicense(int hHandle, int unitIndex,unsigned long *count,unsigned char *type);

//ļϷ
unsigned long 	et_CheckUpdateFile(int hHandle,unsigned char* updateBuffer,int len);

//Զ
unsigned long 	et_RemoteUpdate (int hHandle,unsigned char* updateBuffer,int len);

//ȨļԶļ
unsigned long 	et_GenRemoteUpdateFile (int hHandle, unsigned char* updateBuffer, int len);

//ȡET299汾
unsigned long 	et_GetVersion (int hHandle, unsigned short* version);

/*{{{ MD5 HMAC Wrapper functions.*/
// ʵ
unsigned long 
MD5_HMAC(unsigned char * pucText,        /* pointer to data stream        */
		 unsigned long   ulText_Len,     /* length of data stream         */
		 unsigned char * pucKey,         /* pointer to authentication key */
		 unsigned long   ulKey_Len,      /* length of authentication key  */
		 unsigned char * pucToenKey,     /* inner hashed key and  outer hashed key */
		 unsigned char * pucDigest );    /* caller digest to be filled in */
/*}}}*/

#ifdef __cplusplus
}
#endif


#endif	//__FT_ET299_HEADER_H

