// test.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <stdio.h>
#include "ET99License.h"

#pragma comment(lib,"ET99License.lib")


int main(int argc, char* argv[])
{
	//ET99PID
	char pcPID[9] = "FFC5EB78";
	
	//ET99UserPIN
	char pcUserPIN[17] = "FFFFFFFFFFFFFFFF";
	
	//֤Ϊ16ַ
	char pcLicense[17] = "ET99LiceseTest99";
	long lRet = 0;

	//֤֤Ϊ16ƣǲʾַ
	lRet = ET99App_SetLicense(pcPID, pcUserPIN, 1, pcLicense);
	if(lRet != 0)
	{
		printf("ET99App_SetLicense Error:0x%08X\n",lRet);
		return -1;
	}else
		printf("ET99App_SetLicense Sucess\n");

	//֤ǷЧ
	lRet = ET99App_CheckLicense(pcPID, pcUserPIN, 1, pcLicense);
	if(lRet != 0)
	{
		printf("ET99App_CheckLicense Error:0x%08X\n",lRet);
		return -1;
	}else
		printf("ET99App_CheckLicense Sucess\n");

	//3DESԿ3DESԿΪ24ƣǲʾַ
	char pc3DESKey[25] = "123456781234567812345678";
	lRet = ET99App_Set3DESKey(pcPID, pcUserPIN, pc3DESKey);
	if(lRet != 0)
	{
		printf("ET99App_Set3DESKey Error:0x%08X\n",lRet);
		return -1;
	}else
		printf("ET99App_Set3DESKey Sucess\n");


	char pbData[16] = {0};
	char buf_iv[8] = {0x1,0x2,0x3,0x4,0x5,0x6,0x7,0x8};

	int i =0;

	for(i=0; i<16; ++i)
		pbData[i] = i;

	//3DES
	//ݳҪ8ı
	//pbData˫򻺳ΪܵݣΪܽ
	lRet = ET99App_3DESEnc(pcPID, pcUserPIN, buf_iv, pbData, 16);
	if(lRet != 0)
	{
		printf("ET99App_3DESEnc Error:0x%08X\n",lRet);
		return -1;
	}else
		printf("ET99App_3DESEnc Sucess. Cipher Data:\n");

	for(i=0; i<16; ++i)
	{
		printf("%02X ", (unsigned char)pbData[i]);
	}
	
	//3DES
	//ݳҪ8ı
	//pbData˫򻺳ΪܵݣΪܽ
	lRet = ET99App_3DESDec(pcPID, pcUserPIN, buf_iv, pbData, 16);
	if(lRet != 0)
	{
		printf("\nET99App_3DESEnc Error:0x%08X\n",lRet);
		return -1;
	}else
		printf("\nET99App_3DESEnc Sucess. Plain Data:\n");
	
	for(i=0; i<16; ++i)
	{
		printf("%02X ", (unsigned char)pbData[i]);
	}

	printf("\n");
	return 0;
}
